"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var cli_exports = {};
__export(cli_exports, {
  default: () => cli_default,
  expressPlugin: () => expressPlugin
});
module.exports = __toCommonJS(cli_exports);
var path = __toESM(require("path"));
var import_utils = require("@modern-js/utils");
const expressPlugin = () => ({
  name: "@modern-js/plugin-express",
  setup: (api) => {
    let bffExportsUtils;
    const { useAppContext } = api;
    const runtimeModulePath = path.resolve(__dirname, "../runtime");
    return {
      config() {
        const appContext = useAppContext();
        bffExportsUtils = (0, import_utils.createRuntimeExportsUtils)(appContext.internalDirectory, "server");
        const runtimePath = process.env.NODE_ENV === "development" ? require.resolve("@modern-js/plugin-express/runtime") : "@modern-js/plugin-express/runtime";
        return {
          source: {
            alias: {
              "@modern-js/runtime/server": runtimePath,
              "@modern-js/runtime/express": runtimePath
            }
          }
        };
      },
      collectServerPlugins({ plugins }) {
        plugins.push({
          "@modern-js/plugin-express": "@modern-js/plugin-express/server"
        });
        return {
          plugins
        };
      },
      addRuntimeExports(input) {
        const currentFile = bffExportsUtils.getPath();
        const relativeRuntimeModulePath = path.relative(path.dirname(currentFile), runtimeModulePath);
        const relativeFramePath = path.relative(path.dirname(currentFile), require.resolve("express"));
        bffExportsUtils.addExport(`const pluginRuntime = require('${relativeRuntimeModulePath}');
           const express = require('${relativeFramePath}')
           module.exports = {
            express: express,
             ...pluginRuntime
           }
          `);
        return input;
      }
    };
  }
});
var cli_default = expressPlugin;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  expressPlugin
});
