"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var operators_exports = {};
__export(operators_exports, {
  Middleware: () => Middleware,
  Pipe: () => Pipe
});
module.exports = __toCommonJS(operators_exports);
var import_context = require("../context");
const Pipe = (func) => {
  return {
    name: "pipe",
    // eslint-disable-next-line consistent-return
    async execute(executeHelper, next) {
      const { inputs } = executeHelper;
      const ctx = (0, import_context.useContext)();
      const { res } = ctx;
      if (typeof func === "function") {
        let isPiped = true;
        const end = (value) => {
          isPiped = false;
          if (typeof value === "function") {
            value(res);
            return;
          }
          return value;
        };
        const output = await func(inputs, end);
        if (!isPiped) {
          if (output) {
            return executeHelper.result = output;
          } else {
            return;
          }
        }
        executeHelper.inputs = output;
        await next();
      }
    }
  };
};
const Middleware = (middleware) => {
  return {
    name: "middleware",
    metadata(helper) {
      const middlewares = helper.getMetadata("pipe") || [];
      middlewares.push(middleware);
      helper.setMetadata("middleware", middlewares);
    }
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Middleware,
  Pipe
});
