import { useContext } from "../context";
const Pipe = (func) => {
  return {
    name: "pipe",
    // eslint-disable-next-line consistent-return
    async execute(executeHelper, next) {
      const { inputs } = executeHelper;
      const ctx = useContext();
      const { res } = ctx;
      if (typeof func === "function") {
        let isPiped = true;
        const end = (value) => {
          isPiped = false;
          if (typeof value === "function") {
            value(res);
            return;
          }
          return value;
        };
        const output = await func(inputs, end);
        if (!isPiped) {
          if (output) {
            return executeHelper.result = output;
          } else {
            return;
          }
        }
        executeHelper.inputs = output;
        await next();
      }
    }
  };
};
const Middleware = (middleware) => {
  return {
    name: "middleware",
    metadata(helper) {
      const middlewares = helper.getMetadata("pipe") || [];
      middlewares.push(middleware);
      helper.setMetadata("middleware", middlewares);
    }
  };
};
export {
  Middleware,
  Pipe
};
