import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import * as path from "path";
import express from "express";
import cookieParser from "cookie-parser";
import { fs, compatRequire, logger } from "@modern-js/utils";
import finalhandler from "finalhandler";
import { httpCallBack2HonoMid, sendResponse } from "@modern-js/server-core/base/node";
import { run } from "./context";
import registerRoutes from "./registerRoutes";
var findAppModule = function() {
  var _ref = _async_to_generator(function(apiDir) {
    var exts, paths, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, filename, err;
    return _ts_generator(this, function(_state) {
      switch (_state.label) {
        case 0:
          exts = [
            ".ts",
            ".js"
          ];
          paths = exts.map(function(ext) {
            return path.resolve(apiDir, "app".concat(ext));
          });
          _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = void 0;
          _state.label = 1;
        case 1:
          _state.trys.push([
            1,
            6,
            7,
            8
          ]);
          _iterator = paths[Symbol.iterator]();
          _state.label = 2;
        case 2:
          if (!!(_iteratorNormalCompletion = (_step = _iterator.next()).done))
            return [
              3,
              5
            ];
          filename = _step.value;
          return [
            4,
            fs.pathExists(filename)
          ];
        case 3:
          if (_state.sent()) {
            delete require.cache[filename];
            return [
              2,
              [
                compatRequire(filename),
                require(filename)
              ]
            ];
          }
          _state.label = 4;
        case 4:
          _iteratorNormalCompletion = true;
          return [
            3,
            2
          ];
        case 5:
          return [
            3,
            8
          ];
        case 6:
          err = _state.sent();
          _didIteratorError = true;
          _iteratorError = err;
          return [
            3,
            8
          ];
        case 7:
          try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
          return [
            7
          ];
        case 8:
          return [
            2,
            []
          ];
      }
    });
  });
  return function findAppModule2(apiDir) {
    return _ref.apply(this, arguments);
  };
}();
var initMiddlewares = function(middleware, app) {
  middleware.forEach(function(middlewareItem) {
    var middlewareFunc = typeof middlewareItem === "string" ? compatRequire(middlewareItem) : middlewareItem;
    app.use(middlewareFunc);
  });
};
var useRun = function(app) {
  app.use(function(req, res, next) {
    run({
      req,
      res
    }, next);
  });
};
var createApp = function() {
  var _ref = _async_to_generator(function(param) {
    var apiDir, middlewares, mode, apiHandlerInfos, render, app, appModule, hooks, afterLambdaRegisted;
    return _ts_generator(this, function(_state) {
      switch (_state.label) {
        case 0:
          apiDir = param.apiDir, middlewares = param.middlewares, mode = param.mode, apiHandlerInfos = param.apiHandlerInfos, render = param.render;
          if (!(mode === "framework"))
            return [
              3,
              2
            ];
          return [
            4,
            findAppModule(apiDir)
          ];
        case 1:
          appModule = _state.sent();
          app = appModule[0];
          hooks = appModule[1];
          if (!(app === null || app === void 0 ? void 0 : app.use)) {
            app = express();
          }
          initApp(app);
          if (middlewares && middlewares.length > 0) {
            initMiddlewares(middlewares, app);
          }
          useRun(app);
          registerRoutes(app, apiHandlerInfos);
          if (hooks) {
            afterLambdaRegisted = hooks.afterLambdaRegisted;
            if (afterLambdaRegisted) {
              afterLambdaRegisted(app);
            }
          }
          return [
            3,
            3
          ];
        case 2:
          if (mode === "function") {
            app = express();
            initApp(app);
            if (middlewares && middlewares.length > 0) {
              initMiddlewares(middlewares, app);
            }
            useRun(app);
            registerRoutes(app, apiHandlerInfos);
          } else {
            throw new Error("mode must be function or framework");
          }
          _state.label = 3;
        case 3:
          if (render) {
            app.use(function() {
              var _ref2 = _async_to_generator(function(req, res, next) {
                var response;
                return _ts_generator(this, function(_state2) {
                  switch (_state2.label) {
                    case 0:
                      return [
                        4,
                        render(req.__honoRequest, {
                          logger,
                          nodeReq: req,
                          templates: req.__templates,
                          serverManifest: req.__serverManifest
                        })
                      ];
                    case 1:
                      response = _state2.sent();
                      if (response) {
                        return [
                          2,
                          sendResponse(response, res).then(next)
                        ];
                      }
                      next();
                      return [
                        2
                      ];
                  }
                });
              });
              return function(req, res, next) {
                return _ref2.apply(this, arguments);
              };
            }());
          }
          return [
            2,
            app
          ];
      }
    });
  });
  return function createApp2(_) {
    return _ref.apply(this, arguments);
  };
}();
var initApp = function(app) {
  app.use(cookieParser());
  app.use(express.text());
  app.use(express.urlencoded({
    extended: true
  }));
  app.use(express.json());
  return app;
};
function plugin_default() {
  var app;
  var apiDir;
  var mode;
  var renderHtml;
  return {
    name: "@modern-js/plugin-express",
    pre: [
      "@modern-js/plugin-bff"
    ],
    post: [
      "@modern-js/plugin-server"
    ],
    setup: function(api) {
      return {
        onApiChange: function onApiChange(changes) {
          return _async_to_generator(function() {
            var appContext, middlewares, apiHandlerInfos;
            return _ts_generator(this, function(_state) {
              switch (_state.label) {
                case 0:
                  appContext = api.useAppContext();
                  middlewares = appContext.apiMiddlewares;
                  apiHandlerInfos = appContext.apiHandlerInfos;
                  return [
                    4,
                    createApp({
                      apiDir,
                      middlewares,
                      mode,
                      apiHandlerInfos,
                      render: renderHtml
                    })
                  ];
                case 1:
                  app = _state.sent();
                  return [
                    2,
                    changes
                  ];
              }
            });
          })();
        },
        prepareApiServer: function prepareApiServer(param) {
          var pwd = param.pwd, render = param.render;
          return _async_to_generator(function() {
            var _userConfig_bff, appContext, apiHandlerInfos, apiDirectory, userConfig, middlewares, handler;
            return _ts_generator(this, function(_state) {
              switch (_state.label) {
                case 0:
                  appContext = api.useAppContext();
                  apiHandlerInfos = appContext.apiHandlerInfos;
                  apiDirectory = appContext.apiDirectory;
                  userConfig = api.useConfigContext();
                  middlewares = appContext.apiMiddlewares;
                  mode = appContext.apiMode;
                  renderHtml = ((_userConfig_bff = userConfig.bff) === null || _userConfig_bff === void 0 ? void 0 : _userConfig_bff.enableHandleWeb) && render ? render : void 0;
                  apiDir = apiDirectory || path.join(pwd, "./api");
                  return [
                    4,
                    createApp({
                      apiDir,
                      middlewares,
                      mode,
                      apiHandlerInfos,
                      render: renderHtml
                    })
                  ];
                case 1:
                  app = _state.sent();
                  handler = function(req, res) {
                    return new Promise(function(resolve, reject) {
                      var handler2 = function(err) {
                        if (err) {
                          return reject(err);
                        }
                        finalhandler(req, res, {})(null);
                        return resolve();
                      };
                      res.on("finish", function(err) {
                        if (err) {
                          return reject(err);
                        }
                        return resolve();
                      });
                      return app(req, res, handler2);
                    });
                  };
                  return [
                    2,
                    httpCallBack2HonoMid(handler)
                  ];
              }
            });
          })();
        }
      };
    }
  };
}
;
export {
  plugin_default as default
};
